package SmartAgenda.Interface;

import java.io.*;
import java.net.*;
import java.util.*;
import java.lang.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

import Outils.*;
import SmartAgenda.MyAwt.*;
import SmartAgenda.Moteur.*;
import com.harmonia.renderer.Renderer;

/** Fen&ecirc;tre d'affichage du calendrier.*/
public class fAfficheCal extends MyFrame{
	private boolean administrateur;
	private AGENDA agenda;
	private Frame pere;

	private smart9ActionAdapter[] lSemaineAA;
	private smart9ActionAdapter[] lJourAA;					/*ATTENTION jourActionAdapter[]*/
	private JButton[] ButtonJour;
	private JButton[] ButtonSemaine;

	private Label lMois;
	String mois;
	private JButton bNouveau;
	private JButton bRetour;
	private JButton bPrevious;
	private JButton bNext;
	private static DATE calendrier;

	Renderer r;
	Frame f;
	
/** Cr&eacute;ation d'une instance de la fen&ecirc;tre.
 * @param adm vrai si l'utilisateur est un administrateur, faux sinon.
 * @param a l'agenda.
 * @param p la frame p&egrave;re.
 */
	public fAfficheCal(boolean adm,AGENDA a,Frame p){
		r=new Renderer();
		r.renderUIML("smart9.uiml");
		f=(Frame)r.getPartByName("framefAfficheCal");

		lMois=(Label)r.getPartByName("LabelMois");
		bPrevious=(JButton)r.getPartByName("ButtonPrevious");
		bPrevious.addActionListener(new smart9ActionAdapter(this,1));
		bNext=(JButton)r.getPartByName("ButtonNext");
		bNext.addActionListener(new smart9ActionAdapter(this,2));
		bNouveau=(JButton)r.getPartByName("ButtonNouveau");
		bNouveau.addActionListener(new smart9ActionAdapter(this,3));
		bRetour=(JButton)r.getPartByName("ButtonRetour");
		bRetour.addActionListener(new smart9ActionAdapter(this,4));

		administrateur=adm;
		agenda=a;
		pere=p;
		try{
			calendrier = new DATE();
			init();
			pere.setVisible(false);
		}
		catch (DATEException e){
			Global.msgErreur("Probleme pour la recuperation de la date courante",true);
		}
	}
	
	private void init(){
		ButtonJour=new JButton[42];
		lSemaineAA = new smart9ActionAdapter[6];
		lJourAA = new smart9ActionAdapter[42];				/*ATTENTION jourActionAdapter[42]*/
		ButtonSemaine = new JButton[6];
		
		ButtonSemaine[0]=((JButton)r.getPartByName("ButtonSemaine0"));
		ButtonSemaine[1]=((JButton)r.getPartByName("ButtonSemaine1"));
		ButtonSemaine[2]=((JButton)r.getPartByName("ButtonSemaine2"));
		ButtonSemaine[3]=((JButton)r.getPartByName("ButtonSemaine3"));
		ButtonSemaine[4]=((JButton)r.getPartByName("ButtonSemaine4"));
		ButtonSemaine[5]=((JButton)r.getPartByName("ButtonSemaine5"));
		ButtonJour[0]=((JButton)r.getPartByName("ButtonJour0"));
		ButtonJour[1]=((JButton)r.getPartByName("ButtonJour1"));
		ButtonJour[2]=((JButton)r.getPartByName("ButtonJour2"));
		ButtonJour[3]=((JButton)r.getPartByName("ButtonJour3"));
		ButtonJour[4]=((JButton)r.getPartByName("ButtonJour4"));
		ButtonJour[5]=((JButton)r.getPartByName("ButtonJour5"));
		ButtonJour[6]=((JButton)r.getPartByName("ButtonJour6"));
		ButtonJour[7]=((JButton)r.getPartByName("ButtonJour7"));
		ButtonJour[8]=((JButton)r.getPartByName("ButtonJour8"));
		ButtonJour[9]=((JButton)r.getPartByName("ButtonJour9"));
		ButtonJour[10]=((JButton)r.getPartByName("ButtonJour10"));
		ButtonJour[11]=((JButton)r.getPartByName("ButtonJour11"));
		ButtonJour[12]=((JButton)r.getPartByName("ButtonJour12"));
		ButtonJour[13]=((JButton)r.getPartByName("ButtonJour13"));
		ButtonJour[14]=((JButton)r.getPartByName("ButtonJour14"));
		ButtonJour[15]=((JButton)r.getPartByName("ButtonJour15"));
		ButtonJour[16]=((JButton)r.getPartByName("ButtonJour16"));
		ButtonJour[17]=((JButton)r.getPartByName("ButtonJour17"));
		ButtonJour[18]=((JButton)r.getPartByName("ButtonJour18"));
		ButtonJour[19]=((JButton)r.getPartByName("ButtonJour19"));
		ButtonJour[20]=((JButton)r.getPartByName("ButtonJour20"));
		ButtonJour[21]=((JButton)r.getPartByName("ButtonJour21"));
		ButtonJour[22]=((JButton)r.getPartByName("ButtonJour22"));
		ButtonJour[23]=((JButton)r.getPartByName("ButtonJour23"));
		ButtonJour[24]=((JButton)r.getPartByName("ButtonJour24"));
		ButtonJour[25]=((JButton)r.getPartByName("ButtonJour25"));
		ButtonJour[26]=((JButton)r.getPartByName("ButtonJour26"));
		ButtonJour[27]=((JButton)r.getPartByName("ButtonJour27"));
		ButtonJour[28]=((JButton)r.getPartByName("ButtonJour28"));
		ButtonJour[29]=((JButton)r.getPartByName("ButtonJour29"));
		ButtonJour[30]=((JButton)r.getPartByName("ButtonJour30"));
		ButtonJour[31]=((JButton)r.getPartByName("ButtonJour31"));
		ButtonJour[32]=((JButton)r.getPartByName("ButtonJour32"));
		ButtonJour[33]=((JButton)r.getPartByName("ButtonJour33"));
		ButtonJour[34]=((JButton)r.getPartByName("ButtonJour34"));
		ButtonJour[35]=((JButton)r.getPartByName("ButtonJour35"));
		ButtonJour[36]=((JButton)r.getPartByName("ButtonJour36"));
		ButtonJour[37]=((JButton)r.getPartByName("ButtonJour37"));
		ButtonJour[38]=((JButton)r.getPartByName("ButtonJour38"));
		ButtonJour[39]=((JButton)r.getPartByName("ButtonJour39"));
		ButtonJour[40]=((JButton)r.getPartByName("ButtonJour40"));
		ButtonJour[41]=((JButton)r.getPartByName("ButtonJour41"));
		int j=0;
		for(int i=0;i<42;i++){
			ButtonJour[i].addActionListener(lJourAA[i]=new smart9ActionAdapter());	/*ATTENTION jourActionAdapter(this)*/
			if (i%7==0){
				ButtonSemaine[j].addActionListener(lSemaineAA[j]=new smart9ActionAdapter());
				j++;
			}
		}
		
		afficheCal();
	}

/** Permet de retourner &agrave; la fentre pr&eacute;c&eacute;dente.
 */
	public void back(){
		setVisible(false);
		pere.setVisible(true);
	}

/** Permet de r&eacute;cup&eacute;rer le calendrier.
 * @return le calendrier.
 */	
	public DATE getCalendrier(){
		return calendrier;
	}
	
/** Permet d'afficher la fen&ecirc;tre d'ajout de plage horaire.
 */
	public void nouveau(){
		new afficheCal(agenda,f);
		setVisible(false);
	}
	
/** Permet d'afficher le mois pr&eacute;c&eacute;dent.
 */
	public void previousMonth(){
		calendrier.decMois();
		afficheCal();
	}

/** Permet de dfinir le jour de la semaine.
 * @param jour la valeur du jour de la semaine.
 */	
	public void setJour(int jour){
		calendrier.decalJour(jour-calendrier.getJour());
	}
 
/** Permet d'afficher le mois suivant.
 */
	public void nextMonth(){
		calendrier.incMois();
		afficheCal();
	}

/** Permet d'afficher le calendrier.
 */
	private void afficheCal(){
		lMois.setText(calendrier.moisToString(calendrier.getMois())+" "+calendrier.getAnnee());
		boolean[] sem=new boolean[6];
		for(int i=0;i<6;i++){
			sem[i]=false;
			int semaine=calendrier.semaine(1,calendrier.getMois(),calendrier.getAnnee());
			ButtonSemaine[i].setText(""+(semaine+i));
			ButtonSemaine[i].setBackground(new Color(225,225,225));
			if((semaine+i)==53){
				ButtonSemaine[i].setVisible(false);
			}
			else{
				ButtonSemaine[i].setVisible(false);
			}
		}
		int j=0;
		
		int jour1=calendrier.jourSemaine(1,calendrier.getMois(),calendrier.getAnnee());
		for(int i=0;i<42;i++){
			ButtonJour[i].setVisible(false);
			ButtonJour[i].setBackground(new Color(225,225,225));
			if (i>=jour1 && (i<calendrier.jourMois()+jour1)){
				ButtonJour[i].setText(""+(i-jour1+1));
				ButtonJour[i].removeActionListener(lJourAA[i]);
				ButtonJour[i].addActionListener(lJourAA[i]=new smart9ActionAdapter(this,6,ButtonJour[i].getText()));	/*ATTENTION jourActionAdapter(this,ButtonJour[i].getText(),agenda.m_Plage_Horaire)*/
				ButtonJour[i].setVisible(true);
				try{
					if (agenda.occupe(new DATE(i-jour1+1,calendrier.getMois(),calendrier.getAnnee()))){
						ButtonJour[i].setBackground(new Color(255,200,200));
						sem[i/7]=true;
						ButtonSemaine[i/7].removeActionListener(lSemaineAA[i/7]);
						ButtonSemaine[i/7].addActionListener(lSemaineAA[i/7]=new smart9ActionAdapter(this,5,ButtonSemaine[i/7].getText()));
						ButtonSemaine[i/7].setBackground(new Color(225,125,125));
					}
					else{
						ButtonJour[i].setBackground(new Color(200,200,225));
						ButtonSemaine[i/7].removeActionListener(lSemaineAA[i/7]);
						ButtonSemaine[i/7].addActionListener(lSemaineAA[i/7]=new smart9ActionAdapter(this,5,ButtonSemaine[i/7].getText()));
						if (!sem[i/7]){
							ButtonSemaine[i/7].setBackground(new Color(200,200,200));
						}
					}
				}
				catch (DATEException e){
					ButtonJour[i].setBackground(new Color(225,225,225));
				}
				ButtonSemaine[i/7].setVisible(true);
			}
			else{
				ButtonJour[i].setText("");
				ButtonJour[i].setVisible(false);
				ButtonJour[i].setBackground(new Color(225,225,225));
			}
		}
	}

/** Affiche la fentre de semaine qui correspond au numro spcifi.
 * @param s le numro de la semaine.
 */
	public void affSemaine(int s){
		new afficheSemaine(this,s,agenda,calendrier);
		setVisible(false);
	}

/** Affiche la fentre de jour qui correspond au numro spcifi.
 * @param j le numro du jour.
 */													/*ATTENTION*/
	public void affJour(int j){									/*ATTENTION*/
		new afficheJour(this,j,agenda,calendrier);						/*ATTENTION*/
		setVisible(false);									/*ATTENTION*/
	}												/*ATTENTION*/

/** Permet de rendre la frame visible ou invisible.
 */
	public void setVisible(boolean b){
		f.setVisible(b);
	}

}