package SmartAgenda.Interface;

import java.io.*;
import java.net.*;
import java.util.*;
import java.lang.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

import Outils.*;
import SmartAgenda.MyAwt.*;
import SmartAgenda.Moteur.*;
import com.harmonia.renderer.Renderer;

/** Fen&ecirc;tre &agrave; afficher lors que l'utilisateur met fin &agrave; l'application avant d'avoir sauvegard&eacute; ses modifications.
 */
public class fSave extends MyFrame{
	private boolean end=false;
	private int size=0;
	AGENDA agenda;

	JButton bSauver;
	JButton bQuitter;

	Renderer r;
	Frame f;
	
/** Cr&eacute;ation de l'instance de la Fen&ecirc;tre.
 * @param a l'agenda.
 */
	public fSave(AGENDA a){
		agenda=a;
		r=new Renderer();
		r.renderUIML("smart7.uiml");
		f=(Frame)r.getPartByName("framefSave");

		bSauver=(JButton)r.getPartByName("ButtonOui");
		bSauver.addActionListener(new smart7ActionAdapter(this,1));
		bQuitter=(JButton)r.getPartByName("ButtonNon");
		bQuitter.addActionListener(new smart7ActionAdapter(this,2));
	}

/** Sauvegarde de l'agenda.
 */	
	public void save(){
		agenda.save(false);
		System.exit(1);
		setVisible(false);
	}
	
/** Fin du programme.
 */
	public void quit(){
		System.exit(1);
		setVisible(false);
	}

/** Permet de rendre la frame visible.
 */
	public void setVisible(boolean b){
		f.setVisible(b);
	}

}
