package SmartAgenda.Moteur;

import java.io.*;
import java.net.*;
import java.util.*;
import java.lang.*;

import Outils.*;

/** Classe g&eacute;rant les e-mails.*/
public class E_MAIL {
	private String email;
	private boolean view;
	
/** Cr&eacute;e une nouvelle instance de la classe.
 * @param v d&eacute;termine la visibilit&eacute; de l'information.
 * @param e l'adresse e-mail.
 */
	public E_MAIL(boolean v, String e) {
		email=e;
		view=v;
	}
	
/** Permet de r&eacute;cup&eacute;rer la valeur de l'e-mail.
 * @return la valeur de l'e-mail.
 */
	public String email(){
		return email;
		}

/** Permet de r&eacute;cup&eacute;rer la valeur de la visibilit&eacute; de l'e-mail.
 * @return vrai si l'e-mail peut tre vu par tous les utilisateurs, faux sinon.
 */
	public boolean view(){
		return view;
	}
}
