package SmartAgenda.Moteur;

import java.io.*;
import java.net.*;
import java.util.*;
import java.lang.*;

import Outils.*;

/** Classe g&eacute;rant les lecteurs. */
public class LECTEUR extends UTILISATEUR {
	
/** Cr&eacute;e une nouvelle instance de la classe. */
	public LECTEUR() {
		super();
	}

/** Cr&eacute;e une nouvelle instance de la classe. 
 * @param id identifiant du lecteur.
 * @param nom nom du lecteur.
 * @param prenom pr&eacute;nom du lecteur.
 * @param login login du lecteur.
 * @param pswd password du lecteur.
 */
	public LECTEUR(String id, String nom, String prenom, String login, String pswd) {
		super(id,nom,prenom,login,pswd);
	}
	
/** Cr&eacute;e une nouvelle instance de la classe.
 * @param liste tableau contenant les diff&eacute;rentes valeurs concernant un lecteur.
 Dans l'ordre :  ID, nom, pr&eacute;nom, login
 * @param lPostal liste des adresses postales
 * @param lEmail liste des adresses e-mail
 * @param lPortable liste des num&eacute;ro de portable
 */
	public LECTEUR(String[] liste,Vector lPostal,Vector lEmail,Vector lPortable) {
		super(liste,lPostal,lEmail,lPortable);
		
	}
	
/** Cr&eacute;e une nouvelle instance de la classe.
 * @param s la chaine de caract&egrave;res qui sera pars&eacute;e pour r&eacute;cup&eacute;rer les diff&eacute;rentes valeurs concernant un lecteur.
 */
	public LECTEUR(String s) {
		super(s);
	}

/** Cr&eacute;e une nouvelle instance de la classe ( partir d'un fichier XML).
 * @param s la chaine de caract&egrave;res qui sera pars&eacute;e pour r&eacute;cup&eacute;rer les diff&eacute;rentes valeurs concernant un lecteur.
 * @param b vaut "true" pour XML ("false"  ajouter pour AGD et donc remplacer le constructeur ci-dessus)
 */
//	public LECTEUR(String s, boolean b) {					/*ATTENTION ne fonctionne pas*/
//		super(s,b);
//	}
}
