package SmartAgenda.Interface;

import java.io.*;
import java.net.*;
import java.util.*;
import java.lang.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

import Outils.*;
import SmartAgenda.MyAwt.*;
import SmartAgenda.Moteur.*;
import com.harmonia.renderer.Renderer;

/*Classe implmentant les actions des boutons de l'interface "smart1.uiml" ("afficheCal") sauf "ButtonAnnuler"*/
public class smart1ActionAdapter implements ActionListener{
	Frame frame;
	Frame pere;
	Renderer renderer;
	AGENDA agenda;
//	String URL;
	String[] arguments=new String[6];
	static Vector listeURL = new Vector();		/*liste d'URL*/
//	Vector listeUtil = new Vector();		/*liste de l'ensemble des utilisateurs de l'agenda*/
//	static Vector listeIdPart = new Vector();	/*liste des Id des participants*/
//	static Vector listePart = new Vector();		/*liste d'affichage des participants*/
	int action;

/*Constructeur utilis pour les boutons "Ajouter URL" , "Supprimer URL" et "Supprimer Participants"*/
	public smart1ActionAdapter(Renderer r,int a){
		renderer=r;
		action=a;
	}

/*Constructeur utilis pour le bouton "Ajouter Participants"*/
	public smart1ActionAdapter(Renderer r,int a,Vector v){
		renderer=r;
		action=a;
		listeUtil=v;
	}

/*Constructeur utilis lorsque l'on enregistre l'ajout d'une plage horaire (donc action=0) "ButtonOk"*/
	public smart1ActionAdapter(Renderer r,Frame f,Frame p,AGENDA a){
		renderer=r;
		action=0;
		frame=f;
		pere=p;
		agenda=a;
	}
	
	public void actionPerformed(ActionEvent e){
	/*Enregistrement de l'ajout d'une plage horraire*/
		if (action==0){
			arguments[0]=((TextField)renderer.getPartByName("TextFieldDateDebut")).getText();
			arguments[1]=((TextField)renderer.getPartByName("TextFieldHeureDebut")).getText();
			arguments[2]=((TextField)renderer.getPartByName("TextFieldDateFin")).getText();
			arguments[3]=((TextField)renderer.getPartByName("TextFieldHeureFin")).getText();
			arguments[4]=((TextField)renderer.getPartByName("TextFieldObjet")).getText();
			arguments[5]=((TextArea)renderer.getPartByName("TextAreaDescription")).getText();
			agenda.addPlageHoraire(arguments,listeURL,listeIdPart);
			frame.setVisible(false);
			pere.setVisible(true);
			}
	/*Ajout d'une URL dans la liste d'URL*/
		if (action==1){
			URL=((TextField)renderer.getPartByName("TextFieldURL")).getText();
			listeURL.addElement(URL);
			((JList)renderer.getPartByName("ListURL")).setListData(listeURL);
			((TextField)renderer.getPartByName("TextFieldURL")).setText("");
			}
	/*Suppression d'une URL de la liste d'URL*/
		if (action==2){
			int i=((JList)renderer.getPartByName("ListURL")).getSelectedIndex();
			if (i!=-1){
				System.out.println("Selection a supprimer :"+i);  /*ATTENTION  supprimer*/
				listeURL.removeElementAt(i);
				((JList)renderer.getPartByName("ListURL")).setListData(listeURL);
				}
			}
	/*Ajout d'un utilisateur dans la liste des participants*/
		if (action==3){
			int i=((JList)renderer.getPartByName("ListUtilisateurs")).getSelectedIndex();
			if (i!=-1){
				System.out.println("Utilisateur a ajouter :"+i);  /*ATTENTION  supprimer*/
				listeIdPart.add(((UTILISATEUR)listeUtil.elementAt(i)).getId());
				listePart.add(((UTILISATEUR)listeUtil.elementAt(i)).getNom()+" "+((UTILISATEUR)listeUtil.elementAt(i)).getPrenom());
				((JList)renderer.getPartByName("ListParticipants")).setListData(listePart);
				}
			}
	/*Suppression d'un participant de la liste des participants*/
		if (action==4){
			int i=((JList)renderer.getPartByName("ListParticipants")).getSelectedIndex();
			if (i!=-1){
				System.out.println("Utilisateur a supprimer :"+i);  /*ATTENTION  supprimer*/
				listeIdPart.removeElementAt(i);
				listePart.removeElementAt(i);
				((JList)renderer.getPartByName("ListParticipants")).setListData(listePart);
				}
			}

		for (int i=0;i<listeURL.size();i++){
			System.out.println("L'URL est :"+listeURL.elementAt(i));
			}  /*ATTENTION  supprimer*/
	}
}