package SmartAgenda.Moteur;

import java.io.*;
import java.net.*;
import java.util.*;
import java.lang.*;

import Outils.*;

/** Classe permettant la gestion des administrateurs. */
public class ADMINISTRATEUR extends UTILISATEUR {
	
/** Cr&eacute;e une nouvelle instance de la classe. */
	public ADMINISTRATEUR() {
		super();
	}

/** Cr&eacute;ation d'une nouvelle instance de la classe. 
 * @param id identifiant de l'administrateur.
 * @param nom nom de l'administrateur.
 * @param prenom pr&eacute;nom de l'administrateur.
 * @param login login de l'administrateur.
 * @param pswd password de l'administrateur.
 */
	public ADMINISTRATEUR(String id, String nom, String prenom, String login, String pswd) {
		super(id,nom,prenom,login,pswd);
	}
	
/** Cr&eacute;ation d'une nouvelle instance de la classe.
 * @param liste tableau contenant les diff&eacute;rentes valeurs relative &agrave; un administrateur.
 Dans l'ordre :  ID, nom, pr&eacute;nom, login
 * @param lPostal liste des adresses postales
 * @param lEmail liste des adresses e-mail
 * @param lPortable liste des num&eacute;ro de portable
 */
	public ADMINISTRATEUR(String[] liste,Vector lPostal,Vector lEmail,Vector lPortable) {
		super(liste,lPostal,lEmail,lPortable);
	}
/** Cr&eacute;ation d'une nouvelle instance de la classe.
 * @param s la chaine de caract&egrave;res qui sera pars&eacute;e pour r&eacute;cup&eacute;rer les diff&eacute;rentes valeurs relative &agrave; un administrateur.
 */
	public ADMINISTRATEUR(String s) {
		super(s);
	}

/** Cr&eacute;ation d'une nouvelle instance de la classe ( partir d'un fichier XML).
 * @param s la chaine de caract&egrave;res qui sera pars&eacute;e pour r&eacute;cup&eacute;rer les diff&eacute;rentes valeurs relative &agrave; un administrateur.
 * @param b vaut "true" pour XML ("false"  ajouter pour AGD et donc remplacer le constructeur ci-dessus)
 */
//	public ADMINISTRATEUR(String s, boolean b) {				/*ATTENTION ne fonctionne pas*/
//		super(s,b);
//	}
}
