package SmartAgenda.Moteur;

import java.io.*;
import java.net.*;
import java.util.*;
import java.lang.*;

import Outils.*;

/** Classe permettant la gestion des num&eacute;ro de portable.*/
public class PORTABLE {
	private String portable;
	private boolean view;
	
/** Cr&eacute;e une nouvelle instance de la classe.
 * @param v vrai si le num&eacute;ro de portable peut tre vu par tous les utilisateurs, faux sinon.
 * @param p le num&eacute;ro de portable.
 */
	public PORTABLE(boolean v, String p) {
		portable=p;
		view=v;
	}
	
/** Permet de r&eacute;cup&eacute;rer le num&eacute;ro de portable.
 * @return le num&eacute;ro de portable.
 */
	public String portable(){
		return portable;
		}

/** Permet de r&eacute;cup&eacute;rer la valeur de la visibilit&eacute; du num&eacute;ro de portable.
 * @return vrai si le num&eacute;ro de portable peut tre vu par tous les utilisateurs, faux sinon.
 */
	public boolean view(){
		return view;
		}
}
