package SmartAgenda.MyAwt;

import java.io.*;
import java.net.*;
import java.util.*;
import java.lang.*;
import java.awt.*;
import java.awt.event.*;

import Outils.*;
import SmartAgenda.Moteur.*;
import SmartAgenda.Interface.*;


/** Classe permettant d'impl&eacute;menter des Listes avec ActionListener int&eacute;gr&eacute;.
 */
public class MyList extends java.awt.List implements ItemListener{

	private MyFrame frame;
	private int index;
	
/** Cr&eacute;ation de l'instance.
 * @param lignes nombre de lignes visibles..
 * @param multicol sp&eacute;cifie si plusieurs lignes peuvent tre s&eacute;lectionn&eacute;es ou pas.
 * @param f la frame qui continet l'instance de cette classe.
 * @param i l'index de la ligne s&eacute;lectionn&eacute;e.
 */
	public MyList(int lignes, boolean multicol, MyFrame f, int i){
		super(lignes,multicol);
		frame=f;
		addItemListener(this);
		index=i;
	}
	
/** Cr&eacute;ation de l'instance.
 * @param f la frame qui continet l'instance de cette classe.
 * @param i l'index de la ligne s&eacute;lectionn&eacute;e.
 */
	public MyList(MyFrame f, int i){
		super();
		frame=f;
		addItemListener(this);
		index=i;
	}
	
	public void itemStateChanged(ItemEvent e){
		switch (index){
			case 1 : frame.setSelectedUtil(this.getSelectedIndex());break;
			case 2 : frame.setSelectedEmail(this.getSelectedIndex());break;
			case 3 : frame.setSelectedPortable(this.getSelectedIndex());break;
			default : break;
		}
	}
	
}
