import java.io.*;
import java.net.*;
import java.util.*;
import java.lang.*;
import java.awt.*;

import SmartAgenda.Moteur.*;
import SmartAgenda.Interface.*;
import Outils.*;
import com.harmonia.renderer.Renderer;

/** Classe permettant la gestion de l'agenda.*/
public class smartAgenda{
	private static AGENDA agenda;

	public static void main(String[] args) throws IOException{

	/*Fentre de prsentation de Smart Agenda 2*/
		Renderer r = new Renderer();
		r.renderUIML("smart0.uiml");

/*******************************************/
/* Parametres d'initialisation de l'agenda */
/*******************************************/
		String sagenda = AGENDA.SMART;
		String reponse = "";
		//Nom d'un fichier  tester
		FileReader fTest;
		int typeUtilisateur = 0;
	/* Instanciation de l'applet */
	
	/**************************/
	/* Generation de l'agenda */
	/**************************/
	//Nom du fichier INI
		if (args.length==1) {
			sagenda=args[0];
		}
		else {
			Global.msgErreur("Fichier INI non precise. Par defaut "+AGENDA.SMART+"."+AGENDA.AGD,false);
		}	
	
	//Creation des fichiers INI si necessaire
		try{
			fTest=new FileReader(sagenda+"."+AGENDA.INI);
			fTest.close();
		}
		catch (FileNotFoundException e)
		{
			create_Ini(sagenda);
		}
	
		new fInvite(sagenda);

	}

/**************************************************/
/***** Sauvegardes des parametres de l'agenda *****/
/**************************************************/

//Saisie du repertoire de sauvegarde de l'agenda
/*	private static String nom_Rep ()
	{
		String rep;
		
		System.out.println("Chemin ou seront ranges les fichiers :");
		try{
			rep=new String(Global.readln());
		}
		catch (IOException e){
			rep=new String(AGENDA.REP);
		}
		return rep;
	}*/

//Creation du fichier INI
	private static void create_Ini(String sagenda)
	{
		String fic = sagenda+"."+AGENDA.INI;
		FileWriter fIni;
		
		try 
		{
			System.out.println(fic);
			fIni = new FileWriter(fic,false);
			fIni.write("[REPERTOIRE]"+Global.CRLF);
			fIni.write(AGENDA.REP+Global.CRLF);
			fIni.write("[URL]"+Global.CRLF);
			fIni.write(AGENDA.URI+Global.CRLF);
			fIni.write("[REP DISTANT]"+Global.CRLF);
			fIni.write(AGENDA.REPDIST+Global.CRLF);
			fIni.write("[ADMIN]"+Global.CRLF);
			fIni.write(AGENDA.ADM+Global.CRLF);
			fIni.write("[LECTEUR]"+Global.CRLF);
			fIni.write(AGENDA.LEC+Global.CRLF);
			fIni.write("[CALENDRIER]"+Global.CRLF);
			fIni.write(AGENDA.CAL+Global.CRLF);
			fIni.write("[TTL]"+Global.CRLF);
			fIni.write(AGENDA.TTL+Global.CRLF);
			fIni.write("[LAST ID]"+Global.CRLF);
			fIni.write("0"+Global.CRLF);
			
			fIni.close();
		}
		catch (IOException e) {
			Global.msgErreur ("smartAgenda.create_Ini : "+e.getMessage(),false);
		}
	}
}
